
;Define Globals and their standards
Global HOWMANYPLAYERS=4

Global FPS=60
Global WIDTH=5*HOWMANYPLAYERS
Global HEIGHT=4*HOWMANYPLAYERS
Global GFIELD=32

Global X_OFF=GFIELD/4,Y_OFF=GFIELD/4
Const PLAYER1=1,PLAYER2=2,PLAYER3=3,PLAYER4=4,PLAYER5=5,PLAYER6=6

Global KI_PLAYER[5]

Global P1,P2,P3,P4,P5,P6;TRY
Global timeplayed=MilliSecs()

Global ACT_PLAYER=PLAYER1
Global MX,MY,FX,FY

Global WINNER
Global MOVING=1
Global PImg

Dim win(2,2)
Dim feld(WIDTH,HEIGHT)

;Define KI Players
KI_PLAYER[0]=PLAYER1
KI_PLAYER[1]=PLAYER2
KI_PLAYER[2]=PLAYER3
KI_PLAYER[3]=PLAYER4
KI_PLAYER[4]=PLAYER5
KI_PLAYER[5]=PLAYER6

ReadINI()

Global BCC=KI_PLAYER[0] + KI_PLAYER[1] + KI_PLAYER[2] + KI_PLAYER[3] + KI_PLAYER[4] + KI_PLAYER[5]
If BCC<>21 Then BCC=0


Graphics WIDTH*GFIELD+GFIELD/2,HEIGHT*GFIELD+GFIELD/2,0,2
SetBuffer BackBuffer()

AppTitle "Vier-gewinnt!"
SeedRnd MilliSecs()

PreRenderImages()

Local timer=CreateTimer(FPS)
While Not KeyHit(1)
	Cls
	MouseUpdate()
	GameUpdate()
	WaitTimer timer
	Flip 0
Wend
End

; --- Game Update'n'render
Function GameUpdate()
	If WINNER=0
		If physx()=0
			findwin()
		End If
	Else
		If BCC 
			Delay 5000
			WINNER=0
			ACT_PLAYER=PLAYER1
			For y=0 To HEIGHT-1
				For x=0 To WIDTH-1
					feld(x,y)=0
				Next
			Next
		End If
			
	End If
	
	GameRender()
	
End Function
Function GameRender()
	For y=0 To HEIGHT-1
		For x=0 To WIDTH-1
			DrawImage PImg,x*GFIELD+X_OFF,y*GFIELD+Y_OFF,feld(x,y)
		Next
	Next
	If (ACT_PLAYER<>KI_PLAYER[0] And ACT_PLAYER<>KI_PLAYER[1] And ACT_PLAYER<>KI_PLAYER[2] And ACT_PLAYER<>KI_PLAYER[3] And ACT_PLAYER<>KI_PLAYER[4] And ACT_PLAYER<>KI_PLAYER[5])
		
		Select ACT_PLAYER
			Case PLAYER1
				Color 255,0,0
				Oval FX*GFIELD+4+X_OFF, FY*GFIELD+4+Y_OFF, GFIELD-10,GFIELD-10
			Case PLAYER2
				Color 0,0,255
				Oval FX*GFIELD+4+X_OFF, FY*GFIELD+4+Y_OFF, GFIELD-10,GFIELD-10
			Case PLAYER3
				Color 0,255,0
				Oval FX*GFIELD+4+X_OFF, FY*GFIELD+4+Y_OFF,GFIELD-10,GFIELD-10
			Case PLAYER4
				Color 255,255,0
				Oval FX*GFIELD+4+X_OFF, FY*GFIELD+4+Y_OFF, GFIELD-10,GFIELD-10
			Case PLAYER5
				Color 0,255,255
				Oval FX*GFIELD+4+X_OFF, FY*GFIELD+4+Y_OFF,GFIELD-10,GFIELD-10
			Case PLAYER6
				Color 255,0,255
				Oval FX*GFIELD+4+X_OFF, FY*GFIELD+4+Y_OFF, GFIELD-10,GFIELD-10
		End Select
	End If
	
	If (WINNER=0 And MOVING=1 And ( ACT_PLAYER=KI_PLAYER[0] Or ACT_PLAYER=KI_PLAYER[1] Or ACT_PLAYER=KI_PLAYER[2] Or ACT_PLAYER=KI_PLAYER[3] Or ACT_PLAYER=KI_PLAYER[4] Or ACT_PLAYER=KI_PLAYER[5]))
		updateKI()
	End If	
	If (WINNER<>0)
		Color 255,255,255
		Line win(0,0)*GFIELD+X_OFF+GFIELD/2, win(1,0)*GFIELD+Y_OFF+GFIELD/2, win(0,1)*GFIELD+X_OFF+GFIELD/2, win(1,1)*GFIELD+Y_OFF+GFIELD/2
		Select WINNER
			Case PLAYER1
				Color 128,128,128
				Rect (WIDTH*GFIELD+GFIELD/2)/2-200,32,400,80
				Color 255,0,0
				Text (WIDTH*GFIELD+GFIELD/2)/2,45,"PLAYER 1 (red) wins!",1
				
			Case PLAYER2
				Color 128,128,128
				Rect (WIDTH*GFIELD+GFIELD/2)/2-200,32,400,80
				Color 0,0,255
				Text (WIDTH*GFIELD+GFIELD/2)/2,45,"PLAYER 2 (blue) wins!",1
			Case PLAYER3
				Color 128,128,128
				Rect (WIDTH*GFIELD+GFIELD/2)/2-200,32,400,80
				Color 0,255,0
				Text (WIDTH*GFIELD+GFIELD/2)/2,45,"PLAYER 3 (green) wins!",1
			Case PLAYER4
				Color 128,128,128
				Rect (WIDTH*GFIELD+GFIELD/2)/2-200,32,400,80
				Color 255,255,0
				Text (WIDTH*GFIELD+GFIELD/2)/2,45,"PLAYER 4 (yellow) wins!",1
			Case PLAYER5
				Color 128,128,128
				Rect (WIDTH*GFIELD+GFIELD/2)/2-200,32,400,80
				Color 0,255,255
				Text (WIDTH*GFIELD+GFIELD/2)/2,45,"PLAYER 5 (cyan) wins!",1
			Case PLAYER6
				Color 128,128,128
				Rect (WIDTH*GFIELD+GFIELD/2)/2-200,32,400,80
				Color 255,0,255
				Text (WIDTH*GFIELD+GFIELD/2)/2,45,"PLAYER 6 (pink) wins!",1
		End Select	
		If BCC Then Text (WIDTH*GFIELD+GFIELD/2)/2,65,"- Wait 5sec. -",1 Else Text (WIDTH*GFIELD+GFIELD/2)/2,65,"- Press Mouse to restart -",1
		
		
		
		
		
	End If
End Function
; --- Move'n'win
Function findwin()
	WINNER=0;
	Local pwin=0;		
	For y=0 To HEIGHT-1
		For x=0 To WIDTH-1
			Local TPLAYER=feld(x,y)
			If (TPLAYER<>0)
				
				If (x<WIDTH-3) ; WAAGERECHT
					If (feld(x,y)=TPLAYER And feld(x+1,y)=TPLAYER And feld(x+2,y)=TPLAYER And feld(x+3,y)=TPLAYER)
						WINNER=TPLAYER
						win(0,0)=x
						win(1,0)=y
						win(0,1)=x+3
						win(1,1)=y
					End If
				End If
				If (y<HEIGHT-3) ; SENKRECHT
					If (feld(x,y)=TPLAYER And feld(x,y+1)=TPLAYER And feld(x,y+2)=TPLAYER And feld(x,y+3)=TPLAYER)
						win(0,0)=x
						win(1,0)=y
						win(0,1)=x
						win(1,1)=y+3
						WINNER=TPLAYER
					End If
				End If
				If (x<WIDTH-3 And y<HEIGHT-3) ; SCHRG VON LO NACH RU
					If (feld(x,y)=TPLAYER And feld(x+1,y+1)=TPLAYER And feld(x+2,y+2)=TPLAYER And feld(x+3,y+3)=TPLAYER)
						win(0,0)=x
						win(1,0)=y
						win(0,1)=x+3
						win(1,1)=y+3
						WINNER=TPLAYER
					End If
				End If
				If (x>2 And y<HEIGHT-3) ; SCHRG VON LO NACH RU
					If (feld(x,y)=TPLAYER And feld(x-1,y+1)=TPLAYER And feld(x-2,y+2)=TPLAYER And feld(x-3,y+3)=TPLAYER)
						win(0,0)=x
						win(1,0)=y
						win(0,1)=x-3
						win(1,1)=y+3
						WINNER=TPLAYER
					End If
				End If
			End If
		Next
	Next
	Return pwin
	
End Function
Function physx()
	Local poss=0;
	For y=0 To HEIGHT-1
		For x=0 To WIDTH-1
			If (feld(x,y)<>0 And y<HEIGHT-1)
				If feld(x,y+1)=0 
					feld(x,y+1)=feld(x,y)
					feld(x,y)=0
					poss=1
					MOVING=1-poss
					Return poss
				End If
			End If
		Next
	Next
	MOVING=1-poss
	Return poss
End Function
; --- KI
Function updateKI()
	Local trys=findgoodmove()
	Local KIP=ACT_PLAYER

	If (trys=0)
		Repeat 
			Local KX=myRandom(0,WIDTH)
			If (feld(KX,0)=0)
				feld(KX,0)=KIP
				ACT_PLAYER=ACT_PLAYER+1
				If (ACT_PLAYER>HOWMANYPLAYERS) Then ACT_PLAYER=PLAYER1
				Exit
     	   	End If
		Forever
	Else 
		ACT_PLAYER=ACT_PLAYER+1
		If (ACT_PLAYER>HOWMANYPLAYERS) Then ACT_PLAYER=PLAYER1
	End If
End Function
Function findgoodmove()
	Local KIP=ACT_PLAYER
	For y=0 To HEIGHT-1
		For x=0 To WIDTH-1
			Local TPLAYER=feld(x,y)
			If (TPLAYER<>0)
				If (x>2) ; WAAGERECHT O->W
					If (feld(x,y)=TPLAYER And feld(x-1,y)=TPLAYER And feld(x-2,y)=TPLAYER And feld(x-3,y)=0)
						feld(x-3,0)=KIP
						Return 2
					End If
				End If
				If (x<WIDTH-3) ; WAAGERECHT W->O
					
					If (feld(x,y)=TPLAYER And feld(x+1,y)=TPLAYER And feld(x+2,y)=TPLAYER And feld(x+3,y)=0)
						feld(x+3,0)=KIP
						Return 2
					End If
				End If
				If (y>2) ; SENKRECHT
					If (feld(x,y)=TPLAYER And feld(x,y-1)=TPLAYER And feld(x,y-2)=TPLAYER And feld(x,y-3)=0)
						feld(x,0)=KIP
						Return 2
					End If
					
				End If
				If (x<WIDTH-3 And y>2) ; SCHRG VON LU NACH RO
					If (feld(x,y)=TPLAYER And feld(x+1,y-1)=TPLAYER And feld(x+2,y-2)=TPLAYER And feld(x+3,y-3)=0 And feld(x+3,y-2)<>0)
						feld(x+3,0)=KIP
						Return 2
					End If
					
				End If
				If (x>2 And y<HEIGHT-3) ; SCHRG VON RU NACH LO
					If (feld(x,y)=TPLAYER And feld(x-1,y+1)=TPLAYER And feld(x-2,y+2)=TPLAYER And feld(x-3,y+3)=0  And feld(x-2,y+2)<>0)
						feld(x-3,0)=KIP
						Return 2
					End If
				End If
			End If
		Next 
	Next
	
	For y=0 To HEIGHT-1
		For x=0 To WIDTH-1
			TPLAYER=feld(x,y)
			If (TPLAYER<>0)
				If (x>1) ; WAAGERECHT O->W
					If (feld(x,y)=TPLAYER And feld(x-1,y)=TPLAYER And feld(x-2,y)=0)
						feld(x-2,0)=KIP
						Return 2
					End If
				End If
				If (x<WIDTH-2) ; WAAGERECHT W->O
					If (feld(x,y)=TPLAYER And feld(x+1,y)=TPLAYER And feld(x+2,y)=0)
						feld(x+2,0)=KIP
						Return 2
					End If
				End If
				If (x<WIDTH-3 And y>1) ; SCHRG VON LU NACH RO
					If (feld(x,y)=TPLAYER And feld(x+1,y-1)=TPLAYER And feld(x+2,y-2)=0 And feld(x+3,y-1)<>0)
						feld(x+2,0)=KIP
						Return 2
					End If
				End If
				If (x>2 And y<HEIGHT-2) ; SCHRG VON RU NACH LO
					If (feld(x,y)=TPLAYER And feld(x-1,y+1)=TPLAYER And feld(x-2,y+2)=0 And feld(x-2,y+1)<>0)
						feld(x-2,0)=KIP
						Return 2
					End If
				End If
			End If
		Next
	Next
	Return 0
	
End Function
; --- Init'n'Runtime
Function myRandom(low,high)
	Return (Rnd(0,1) * (high - low) + low)
End Function
Function MouseUpdate()
	If MouseHit(1)
		If feld(FX,FY)=0 And ACT_PLAYER<>KI_PLAYER[0] And ACT_PLAYER<>KI_PLAYER[1] And ACT_PLAYER<>KI_PLAYER[2] And ACT_PLAYER<>KI_PLAYER[3] And ACT_PLAYER<>KI_PLAYER[4] And ACT_PLAYER<>KI_PLAYER[5] And MOVING=1
			feld(FX,FY)=ACT_PLAYER
			ACT_PLAYER=ACT_PLAYER+1
			If (ACT_PLAYER>HOWMANYPLAYERS) Then ACT_PLAYER=PLAYER1
			
		End If
		If (WINNER<>0)
			WINNER=0
			ACT_PLAYER=PLAYER1
			For y=0 To HEIGHT-1
				For x=0 To WIDTH-1
					feld(x,y)=0
				Next
			Next
		End If
	End If
	
	MX = MouseX()
	MY = MouseY()
	If (MX-X_OFF)/GFIELD<WIDTH And (MY-Y_OFF)/GFIELD<HEIGHT
		FX = (MX-X_OFF)/GFIELD
		FY = 0
	End If
	
End Function
Function ReadINI()
	Local file=ReadFile("config.ini"),arg=0
	While Eof(file)=0
		Local msg$=ReadLine(file)
		Select Left(msg,2)
			Case "FP"
				Local fp%=Mid(msg,Instr(msg," = ")+3)
				arg=arg+1
			Case "PL"
				Local pl%=Mid(msg,Instr(msg," = ")+3)
				arg=arg+1
			Case "GF"
				Local gf%=Mid(msg,Instr(msg," = ")+3)
				arg=arg+1
			Case "K0"
				Local k0$=Mid(msg,Instr(msg," = ")+3)
				arg=arg+1
			Case "K1"
				Local k1$=Mid(msg,Instr(msg," = ")+3)
				arg=arg+1
			Case "K2"
				Local k2$=Mid(msg,Instr(msg," = ")+3)
				arg=arg+1
			Case "K3"
				Local k3$=Mid(msg,Instr(msg," = ")+3)
				arg=arg+1
			Case "K4"
				Local k4$=Mid(msg,Instr(msg," = ")+3)
				arg=arg+1
			Case "K5"
				Local k5$=Mid(msg,Instr(msg," = ")+3)
				arg=arg+1
		End Select
	Wend
	If arg=9
		FPS=fp
		HOWMANYPLAYERS=pl
		GFIELD=gf
		;Define KI Players
		If Lower(k0)="true" Then KI_PLAYER[0]=PLAYER1 Else KI_PLAYER[0]=0
		If Lower(k1)="true" Then KI_PLAYER[1]=PLAYER2 Else KI_PLAYER[1]=0
		If Lower(k2)="true" Then KI_PLAYER[2]=PLAYER3 Else KI_PLAYER[2]=0
		If Lower(k3)="true" Then KI_PLAYER[3]=PLAYER4 Else KI_PLAYER[3]=0
		If Lower(k4)="true" Then KI_PLAYER[4]=PLAYER5 Else KI_PLAYER[4]=0
		If Lower(k5)="true" Then KI_PLAYER[5]=PLAYER6 Else KI_PLAYER[5]=0
		
		Return 1
	Else
		Return 0
	End If
End Function
Function PreRenderImages()
	PImg=CreateImage(GFIELD,GFIELD,7)
	For i=0 To 6
		SetBuffer ImageBuffer(PImg,i)
		Select i
			Case 0
				Color 128,128,128
			Case 1
				Color 255,0,0
			Case 2
				Color 0,0,255
			Case 3
				Color 0,255,0
			Case 4
				Color 255,255,0
			Case 5
				Color 0,255,255
			Case 6
				Color 255,0,255
				
		End Select
		Oval 0,0, GFIELD-2, GFIELD-2
	Next
	SetBuffer BackBuffer()
End Function
Function Print(txt$)
	Local file=OpenFile("log.txt")
	If file=0 Then file=WriteFile("log.txt")
	SeekFile file,FileSize("log.txt")
	WriteLine file,txt
	CloseFile file
End Function
;~IDEal Editor Parameters:
;~F#A0#D2#E5#F8#146#149#164#197#1B0
;~C#Blitz3D